<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/distpointline.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>distpointline.c</h1><a href="distpointline_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: distpointline.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">/* Weisstein, Eric W. &quot;Point-Line Distance--3-Dimensional.&quot; From MathWorld--A Wolfram Web Resource.</span>
<a name="l00030"></a>00030 <span class="comment"> * http://mathworld.wolfram.com/Point-LineDistance3-Dimensional.html</span>
<a name="l00031"></a>00031 <span class="comment"> */</span>
<a name="l00032"></a><a class="code" href="util_8h.html#ac72e65a2b520879279f161bdba479892">00032</a> <span class="keywordtype">int</span> <a class="code" href="distpointline_8c.html#ac72e65a2b520879279f161bdba479892">DistPointLine</a>(PetscReal *point,PetscReal *linepoint,PetscReal *linevec,PetscReal *dist)
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034   PetscReal x0[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],x1[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],x2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,point,1,x0,1);
<a name="l00037"></a>00037   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,linepoint,1,x1,1);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,linepoint,1,x2,1);
<a name="l00040"></a>00040   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0,linevec,1,x2,1);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   PetscReal d01[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],d02[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],d12[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,x1,1,d01,1);
<a name="l00045"></a>00045   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,x0,1,d01,1);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,x2,1,d02,1);
<a name="l00048"></a>00048   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,x0,1,d02,1);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,x2,1,d12,1);
<a name="l00051"></a>00051   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,x1,1,d12,1);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   PetscReal t[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00054"></a>00054   <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,d01,d02,t);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   PetscReal n1,n2;
<a name="l00057"></a>00057   n1=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,t,1);
<a name="l00058"></a>00058   n2=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,d12,1);
<a name="l00059"></a>00059   <span class="keywordflow">if</span> (n1&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00060"></a>00060     *dist=0.0;
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062   <span class="keywordflow">else</span> {
<a name="l00063"></a>00063     *dist=n1/n2;
<a name="l00064"></a>00064   }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="keywordflow">return</span>(0);
<a name="l00067"></a>00067 }
<a name="l00068"></a>00068 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

